"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var fs = require("fs");

var _require = require("path"),
    extname = _require.extname,
    resolve = _require.resolve,
    parse = _require.parse,
    join = _require.join;

var readdir = require("recursive-readdir");

var normalizePath = require("normalize-path");

var _require2 = require("./constants"),
    OPTION_DEFAULT_REPL_DIRECTORY = _require2.OPTION_DEFAULT_REPL_DIRECTORY,
    OPTION_DEFAULT_CODEPEN = _require2.OPTION_DEFAULT_CODEPEN;

exports.createPages = /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(_ref, _temp) {
    var actions, reporter, _ref3, _ref3$directory, directory, _ref3$codepen, codepen, createPage, files, resolvedDirectory;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            actions = _ref.actions, reporter = _ref.reporter;
            _ref3 = _temp === void 0 ? {} : _temp, _ref3$directory = _ref3.directory, directory = _ref3$directory === void 0 ? OPTION_DEFAULT_REPL_DIRECTORY : _ref3$directory, _ref3$codepen = _ref3.codepen, codepen = _ref3$codepen === void 0 ? OPTION_DEFAULT_CODEPEN : _ref3$codepen;
            codepen = (0, _extends2.default)({}, OPTION_DEFAULT_CODEPEN, codepen);

            if (!directory.endsWith("/")) {
              directory += "/";
            }

            createPage = actions.createPage;

            if (!fs.existsSync(directory)) {
              reporter.panic("Invalid REPL directory specified: \"" + directory + "\"");
            }

            if (!fs.existsSync(codepen.redirectTemplate)) {
              reporter.panic("Invalid REPL redirectTemplate specified: \"" + codepen.redirectTemplate + "\"");
            }

            _context.prev = 7;
            _context.next = 10;
            return readdir(directory);

          case 10:
            files = _context.sent;

            if (!(files.length === 0)) {
              _context.next = 14;
              break;
            }

            console.warn("Specified REPL directory \"" + directory + "\" contains no files");
            return _context.abrupt("return");

          case 14:
            // escape backslashes for windows
            resolvedDirectory = resolve(directory);
            files.forEach(function (file) {
              if (extname(file) === ".js" || extname(file) === ".jsx") {
                var parsedFile = parse(file);
                var relativeDir = parsedFile.dir.replace("" + resolvedDirectory, "");
                var slug = "redirect-to-codepen" + normalizePath(relativeDir) + "/" + parsedFile.name;
                var code = fs.readFileSync(file, "utf8");
                var css;

                if (codepen.includeMatchingCSS === true) {
                  try {
                    css = fs.readFileSync(join(parsedFile.dir, parsedFile.name + ".css"), "utf8");
                  } catch (err) {
                    // If the file doesn't exist, we gracefully ignore the error
                    if (err.code !== "ENOENT") {
                      throw err;
                    }
                  }
                } // Codepen configuration.
                // https://blog.codepen.io/documentation/api/prefill/


                var action = "https://codepen.io/pen/define";
                var payload = JSON.stringify({
                  editors: "0010",
                  html: codepen.html,
                  js: code,
                  js_external: codepen.externals.join(";"),
                  js_pre_processor: "babel",
                  layout: "left",
                  css: css
                });
                createPage({
                  path: slug,
                  component: normalizePath(resolve(codepen.redirectTemplate)),
                  context: {
                    action: action,
                    payload: payload
                  }
                });
              }
            });
            _context.next = 21;
            break;

          case 18:
            _context.prev = 18;
            _context.t0 = _context["catch"](7);
            reporter.panic("\n      Error in gatsby-remark-code-repls plugin: cannot read directory " + directory + ".\n      More details can be found in the error reporting below.\n      ", _context.t0);

          case 21:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[7, 18]]);
  }));

  return function (_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();